/*
* This file is part of Firestorm NIDS
* Copyright (c) 2001 Gianni Tedesco
*
*    Firestorm is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    Firestorm is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with Firestorm; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include <arp.h>
PLUGIN_DECLARE_STD_IMPORTS;

proc_demux_add_handler add_demux;

uint _PLUGIN_INIT (p_plugin_in in, p_plugin_out out)
{
	PLUGIN_CHECK_PARAMS(in);
	PLUGIN_IMPORT_STD;
	PLUGIN_NAME("proto/arp");
	PLUGIN_DESC("ARP/RARP is an ethernet address resolution protocol");
	PLUGIN_VERS(1,1);
	
	add_demux=in->add_demux;

	if ( !(add_demux(LTYPE_NET, demux_callback)) ) {
		return PLUGIN_ERR_FAIL;
	}else{	
		return PLUGIN_ERR_OK;
	}
}

/* This is where we would cleanup our shit */
uint _PLUGIN_UNLOAD (void)
{
	return PLUGIN_ERR_OK;
}

/* This is our actual demultiplex handler */

#define NPROTO_ARP	0x0806
#define NPROTO_RARP 	0x8035

int demux_callback(p_packet p, int layer)
{
	if ( !p->layer[layer].h.raw ) return DEMUX_UNKNOWN;

	if ( p->layer[layer].id != NPROTO_ARP &&
		p->layer[layer].id != NPROTO_RARP ) return DEMUX_UNKNOWN;

	if ( p->layer[layer].id == NPROTO_ARP ){
		p->layer[layer].name = "ARP";
	}else{
		p->layer[layer].name = "RARP";
	}

	return DEMUX_FINISHED;
}
